#!/usr/bin/env node
"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncIterator) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator];
    return m ? m.call(o) : typeof __values === "function" ? __values(o) : o[Symbol.iterator]();
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var bodyParser = require("body-parser");
var errorhandler = require("errorhandler");
var express = require("express");
var fs = require("fs-extra");
var path = require("path");
var program = require("commander");
var open = require("open");
var _ = require("lodash");
var csv = require("./csv");
var sample_template_1 = require("./sample-template");
var utils = require("./utils");
program
    .version('2.0.5')
    .usage('[options] template.html tasks.csv outputs.csv')
    .option('-p, --port <n>', 'Run on this port (default 4321)', parseInt)
    .option('-s, --static-dir <dir>', 'Serve static content from this directory. Default is same directory as template file.')
    .option('-w, --write-template', 'Generate a stub template file based on the input CSV.')
    .parse(process.argv);
var args = program.args, writeTemplate = program.writeTemplate;
if (!((3 === args.length && !writeTemplate) ||
    (1 === args.length && writeTemplate))) {
    program.help();
}
if (writeTemplate) {
    // tasks.csv is the only input with --write-template.
    args.unshift('');
    args.push('');
}
var templateFile = args[0], tasksFile = args[1], outputsFile = args[2];
var port = program.port || 4321;
// --static-dir is particularly useful for classify-images, where the template file is in a
// temporary directory but the image files could be anywhere.
var staticDir = program['staticDir'] || path.dirname(templateFile);
var flash = ''; // this is used to show warnings in the web UI.
function renderTemplate(_a) {
    var task = _a.task, numCompleted = _a.numCompleted, numTotal = _a.numTotal;
    return __awaiter(this, void 0, void 0, function () {
        var template, fullDict, k, userHtml, thisFlash, sourceInputs;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, fs.readFile(templateFile, { encoding: 'utf8' })];
                case 1:
                    template = _b.sent();
                    fullDict = {};
                    for (k in task) {
                        fullDict[k] = utils.htmlEntities(task[k]);
                    }
                    // Note: these two fields are not available in mechanical turk.
                    fullDict['ALL_JSON'] = utils.htmlEntities(JSON.stringify(task, null, 2));
                    fullDict['ALL_JSON_RAW'] = JSON.stringify(task);
                    userHtml = utils.renderTemplate(template, fullDict);
                    thisFlash = flash;
                    flash = '';
                    sourceInputs = _.map(task, function (v, k) {
                        return "<input type=hidden name=\"" + k + "\" value=\"" + utils.htmlEntities(v) + "\">";
                    }).join('\n');
                    return [2 /*return*/, utils.dedent(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    <!doctype html>\n    <html>\n    <title>", " / ", " - localturk</title>\n    <body><form action=/submit method=post>\n    <p>", " / ", " <span style=\"background: yellow\">", "</span></p>\n    ", "\n    ", "\n    <hr/><input type=submit />\n    </form>\n    <script>\n    // Support keyboard shortcuts via, e.g. <.. data-key=\"1\" />\n    window.addEventListener(\"keydown\", function(e) {\n      if (document.activeElement !== document.body) return;\n      var key = e.key;\n      const el = document.querySelector('[data-key=\"' + key + '\"]');\n      if (el) {\n        e.preventDefault();\n        el.click();\n      }\n    });\n    </script>\n    </body>\n    </html>\n  "], ["\n    <!doctype html>\n    <html>\n    <title>", " / ", " - localturk</title>\n    <body><form action=/submit method=post>\n    <p>", " / ", " <span style=\"background: yellow\">", "</span></p>\n    ", "\n    ", "\n    <hr/><input type=submit />\n    </form>\n    <script>\n    // Support keyboard shortcuts via, e.g. <.. data-key=\"1\" />\n    window.addEventListener(\"keydown\", function(e) {\n      if (document.activeElement !== document.body) return;\n      var key = e.key;\n      const el = document.querySelector('[data-key=\"' + key + '\"]');\n      if (el) {\n        e.preventDefault();\n        el.click();\n      }\n    });\n    </script>\n    </body>\n    </html>\n  "])), numCompleted, numTotal, numCompleted, numTotal, thisFlash, sourceInputs, userHtml)];
            }
        });
    });
}
function readCompletedTasks() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (!fs.pathExistsSync(outputsFile))
                return [2 /*return*/, []];
            return [2 /*return*/, csv.readAllRowObjects(outputsFile)];
        });
    });
}
function isTaskCompleted(task, completedTasks) {
    var normTask = utils.normalizeValues(task);
    for (var _i = 0, completedTasks_1 = completedTasks; _i < completedTasks_1.length; _i++) {
        var d = completedTasks_1[_i];
        if (utils.isSupersetOf(d, normTask))
            return true;
    }
    return false;
}
function checkTaskOutput(task) {
    return __awaiter(this, void 0, void 0, function () {
        var headers, k;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, csv.readHeaders(tasksFile)];
                case 1:
                    headers = _a.sent();
                    for (k in task) {
                        if (headers.indexOf(k) === -1)
                            return [2 /*return*/]; // there's a new key.
                    }
                    flash = 'No new keys in output. Make sure your &lt;input&gt; elements have "name" attributes';
                    return [2 /*return*/];
            }
        });
    });
}
function getNextTask() {
    return __awaiter(this, void 0, void 0, function () {
        var completedTasks, nextTask, numTotal, _a, _b, task, e_1_1, e_1, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, readCompletedTasks()];
                case 1:
                    completedTasks = (_d.sent()).map(utils.normalizeValues);
                    numTotal = 0;
                    _d.label = 2;
                case 2:
                    _d.trys.push([2, 8, 9, 14]);
                    _a = __asyncValues(csv.readRowObjects(tasksFile));
                    _d.label = 3;
                case 3: return [4 /*yield*/, _a.next()];
                case 4:
                    if (!(_b = _d.sent(), !_b.done)) return [3 /*break*/, 7];
                    return [4 /*yield*/, _b.value];
                case 5:
                    task = _d.sent();
                    numTotal++;
                    if (!nextTask && !isTaskCompleted(utils.normalizeValues(task), completedTasks)) {
                        nextTask = task;
                    }
                    _d.label = 6;
                case 6: return [3 /*break*/, 3];
                case 7: return [3 /*break*/, 14];
                case 8:
                    e_1_1 = _d.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 14];
                case 9:
                    _d.trys.push([9, , 12, 13]);
                    if (!(_b && !_b.done && (_c = _a.return))) return [3 /*break*/, 11];
                    return [4 /*yield*/, _c.call(_a)];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11: return [3 /*break*/, 13];
                case 12:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 13: return [7 /*endfinally*/];
                case 14: return [2 /*return*/, {
                        task: nextTask,
                        numCompleted: _.size(completedTasks),
                        numTotal: numTotal,
                    }];
            }
        });
    });
}
var app = express();
app.use(bodyParser.urlencoded({ extended: false }));
app.use(errorhandler());
app.use(express.static(path.resolve(staticDir)));
app.get('/', utils.wrapPromise(function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var nextTask, html;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, getNextTask()];
            case 1:
                nextTask = _a.sent();
                if (!nextTask.task) return [3 /*break*/, 3];
                console.log(nextTask.task);
                return [4 /*yield*/, renderTemplate(nextTask)];
            case 2:
                html = _a.sent();
                res.send(html);
                return [3 /*break*/, 4];
            case 3:
                res.send('DONE');
                process.exit(0);
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); }));
app.post('/submit', utils.wrapPromise(function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var task;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                task = req.body;
                return [4 /*yield*/, csv.appendRow(outputsFile, task)];
            case 1:
                _a.sent();
                checkTaskOutput(task); // sets the "flash" variable with any errors.
                console.log('Saved ' + JSON.stringify(task));
                res.redirect('/');
                return [2 /*return*/];
        }
    });
}); }));
app.post('/delete-last', utils.wrapPromise(function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var row;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, csv.deleteLastRow(outputsFile)];
            case 1:
                row = _a.sent();
                console.log('Deleting', row);
                res.redirect('/');
                return [2 /*return*/];
        }
    });
}); }));
if (writeTemplate) {
    (function () { return __awaiter(_this, void 0, void 0, function () {
        var columns;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, csv.readHeaders(tasksFile)];
                case 1:
                    columns = _a.sent();
                    console.log(sample_template_1.makeTemplate(columns));
                    return [2 /*return*/];
            }
        });
    }); })().catch(function (e) {
        console.error(e);
    });
}
else {
    app.listen(port);
    var url = "http://localhost:" + port;
    console.log('Running local turk on', url);
    open(url);
}
var templateObject_1;
